Index: /NEMO/trunk/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbccpl.F90	(revision 14072)
@@ -2373,8 +2375,8 @@
 
          SELECT CASE( sn_snd_alb%clcat )
-            CASE( 'yes' )   
+            CASE( 'yes' )
                CALL cpl_snd( jps_albice, isec, ztmp3, info )      !-> MV this has never been checked in coupled mode
-            CASE( 'no'  )   
-               CALL cpl_snd( jps_albice, isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ), info ) 
+            CASE( 'no'  )
+               CALL cpl_snd( jps_albice, isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ), info )
          END SELECT
       ENDIF
@@ -2388,5 +2390,5 @@
       ENDIF
       !                                                      ! ------------------------- !
-      !                                                      !  Ice fraction & Thickness ! 
+      !                                                      !  Ice fraction & Thickness !
       !                                                      ! ------------------------- !
       ! Send ice fraction field to atmosphere
@@ -2401,10 +2403,10 @@
 
 #if defined key_si3 || defined key_cice
-      ! If this coupling was successful then save ice fraction for use between coupling points. 
-      ! This is needed for some calculations where the ice fraction at the last coupling point 
-      ! is needed. 
-      IF(  info == OASIS_Sent    .OR. info == OASIS_ToRest .OR. & 
-         & info == OASIS_SentOut .OR. info == OASIS_ToRestOut ) THEN 
-         IF ( sn_snd_thick%clcat == 'yes' ) THEN 
+      ! If this coupling was successful then save ice fraction for use between coupling points.
+      ! This is needed for some calculations where the ice fraction at the last coupling point
+      ! is needed.
+      IF(  info == OASIS_Sent    .OR. info == OASIS_ToRest .OR. &
+         & info == OASIS_SentOut .OR. info == OASIS_ToRestOut ) THEN
+         IF ( sn_snd_thick%clcat == 'yes' ) THEN
            a_i_last_couple(:,:,1:jpl) = a_i(:,:,1:jpl)
          ENDIF
@@ -2420,5 +2422,5 @@
          CALL cpl_snd( jps_fice1, isec, ztmp3, info )
       ENDIF
-      
+
       ! Send ice fraction field to OPA (sent by SAS in SAS-OPA coupling)
       IF( ssnd(jps_fice2)%laction ) THEN
@@ -2427,11 +2429,11 @@
       ENDIF
 
-      ! Send ice and snow thickness field 
-      IF( ssnd(jps_hice)%laction .OR. ssnd(jps_hsnw)%laction ) THEN 
+      ! Send ice and snow thickness field
+      IF( ssnd(jps_hice)%laction .OR. ssnd(jps_hsnw)%laction ) THEN
          SELECT CASE( sn_snd_thick%cldes)
          CASE( 'none'                  )       ! nothing to do
-         CASE( 'weighted ice and snow' )   
+         CASE( 'weighted ice and snow' )
             SELECT CASE( sn_snd_thick%clcat )
-            CASE( 'yes' )   
+            CASE( 'yes' )
                ztmp3(:,:,1:jpl) =  h_i(:,:,1:jpl) * a_i(:,:,1:jpl)
                ztmp4(:,:,1:jpl) =  h_s(:,:,1:jpl) * a_i(:,:,1:jpl)
@@ -2444,5 +2446,5 @@
             CASE default                  ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_thick%clcat' )
             END SELECT
-         CASE( 'ice and snow'         )   
+         CASE( 'ice and snow'         )
             SELECT CASE( sn_snd_thick%clcat )
             CASE( 'yes' )
@@ -2467,58 +2469,58 @@
 #if defined key_si3
       !                                                      ! ------------------------- !
-      !                                                      !      Ice melt ponds       ! 
-      !                                                      ! ------------------------- !
-      ! needed by Met Office: 1) fraction of ponded ice 2) local/actual pond depth 
-      IF( ssnd(jps_a_p)%laction .OR. ssnd(jps_ht_p)%laction ) THEN 
-         SELECT CASE( sn_snd_mpnd%cldes)  
-         CASE( 'ice only' )  
-            SELECT CASE( sn_snd_mpnd%clcat )  
-            CASE( 'yes' )  
+      !                                                      !      Ice melt ponds       !
+      !                                                      ! ------------------------- !
+      ! needed by Met Office: 1) fraction of ponded ice 2) local/actual pond depth
+      IF( ssnd(jps_a_p)%laction .OR. ssnd(jps_ht_p)%laction ) THEN
+         SELECT CASE( sn_snd_mpnd%cldes)
+         CASE( 'ice only' )
+            SELECT CASE( sn_snd_mpnd%clcat )
+            CASE( 'yes' )
                ztmp3(:,:,1:jpl) =  a_ip_eff(:,:,1:jpl)
-               ztmp4(:,:,1:jpl) =  h_ip(:,:,1:jpl)  
-            CASE( 'no' )  
-               ztmp3(:,:,:) = 0.0  
-               ztmp4(:,:,:) = 0.0  
-               DO jl=1,jpl  
+               ztmp4(:,:,1:jpl) =  h_ip(:,:,1:jpl)
+            CASE( 'no' )
+               ztmp3(:,:,:) = 0.0
+               ztmp4(:,:,:) = 0.0
+               DO jl=1,jpl
                  ztmp3(:,:,1) = ztmp3(:,:,1) + a_ip_frac(:,:,jpl)
                  ztmp4(:,:,1) = ztmp4(:,:,1) + h_ip(:,:,jpl)
-               ENDDO  
-            CASE default   ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_mpnd%clcat' )  
-            END SELECT  
-         CASE default      ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_mpnd%cldes' )     
-         END SELECT  
-         IF( ssnd(jps_a_p)%laction  )   CALL cpl_snd( jps_a_p , isec, ztmp3, info )     
-         IF( ssnd(jps_ht_p)%laction )   CALL cpl_snd( jps_ht_p, isec, ztmp4, info )     
-      ENDIF 
-      ! 
-      !                                                      ! ------------------------- !
-      !                                                      !     Ice conductivity      ! 
+               ENDDO
+            CASE default   ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_mpnd%clcat' )
+            END SELECT
+         CASE default      ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_mpnd%cldes' )
+         END SELECT
+         IF( ssnd(jps_a_p)%laction  )   CALL cpl_snd( jps_a_p , isec, ztmp3, info )
+         IF( ssnd(jps_ht_p)%laction )   CALL cpl_snd( jps_ht_p, isec, ztmp4, info )
+      ENDIF
+      !
+      !                                                      ! ------------------------- !
+      !                                                      !     Ice conductivity      !
       !                                                      ! ------------------------- !
       ! needed by Met Office
-      IF( ssnd(jps_kice)%laction ) THEN 
-         SELECT CASE( sn_snd_cond%cldes) 
-         CASE( 'weighted ice' )    
-            SELECT CASE( sn_snd_cond%clcat ) 
-            CASE( 'yes' )    
-	       ztmp3(:,:,1:jpl) =  cnd_ice(:,:,1:jpl) * a_i(:,:,1:jpl) 
-            CASE( 'no' ) 
-               ztmp3(:,:,:) = 0.0 
-               DO jl=1,jpl 
-                 ztmp3(:,:,1) = ztmp3(:,:,1) + cnd_ice(:,:,jl) * a_i(:,:,jl) 
-               ENDDO 
-            CASE default   ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_cond%clcat' ) 
-            END SELECT 
-         CASE( 'ice only' )    
-           ztmp3(:,:,1:jpl) = cnd_ice(:,:,1:jpl) 
-         CASE default      ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_cond%cldes' )     
-         END SELECT 
-         IF( ssnd(jps_kice)%laction )   CALL cpl_snd( jps_kice, isec, ztmp3, info ) 
-      ENDIF 
+      IF( ssnd(jps_kice)%laction ) THEN
+         SELECT CASE( sn_snd_cond%cldes)
+         CASE( 'weighted ice' )
+            SELECT CASE( sn_snd_cond%clcat )
+            CASE( 'yes' )
+	       ztmp3(:,:,1:jpl) =  cnd_ice(:,:,1:jpl) * a_i(:,:,1:jpl)
+            CASE( 'no' )
+               ztmp3(:,:,:) = 0.0
+               DO jl=1,jpl
+                 ztmp3(:,:,1) = ztmp3(:,:,1) + cnd_ice(:,:,jl) * a_i(:,:,jl)
+               ENDDO
+            CASE default   ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_cond%clcat' )
+            END SELECT
+         CASE( 'ice only' )
+           ztmp3(:,:,1:jpl) = cnd_ice(:,:,1:jpl)
+         CASE default      ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_cond%cldes' )
+         END SELECT
+         IF( ssnd(jps_kice)%laction )   CALL cpl_snd( jps_kice, isec, ztmp3, info )
+      ENDIF
 #endif
 
       !                                                      ! ------------------------- !
-      !                                                      !  CO2 flux from PISCES     ! 
-      !                                                      ! ------------------------- !
-      IF( ssnd(jps_co2)%laction .AND. l_co2cpl )   THEN 
+      !                                                      !  CO2 flux from PISCES     !
+      !                                                      ! ------------------------- !
+      IF( ssnd(jps_co2)%laction .AND. l_co2cpl )   THEN
          ztmp1(:,:) = oce_co2(:,:) * 1000.  ! conversion in molC/m2/s
          CALL cpl_snd( jps_co2, isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ) , info )
@@ -2528,5 +2530,5 @@
       IF( ssnd(jps_ocx1)%laction ) THEN                      !      Surface current      !
          !                                                   ! ------------------------- !
-         !    
+         !
          !                                                  j+1   j     -----V---F
          ! surface velocity always sent from T point                     !       |
@@ -2538,16 +2540,16 @@
          !                                                               i      i+1 (for I)
          IF( nn_components == jp_iam_opa ) THEN
-            zotx1(:,:) = uu(:,:,1,Kmm)  
-            zoty1(:,:) = vv(:,:,1,Kmm)  
-         ELSE        
+            zotx1(:,:) = uu(:,:,1,Kmm)
+            zoty1(:,:) = vv(:,:,1,Kmm)
+         ELSE
             SELECT CASE( TRIM( sn_snd_crt%cldes ) )
             CASE( 'oce only'             )      ! C-grid ==> T
                DO_2D( 0, 0, 0, 0 )
                   zotx1(ji,jj) = 0.5 * ( uu(ji,jj,1,Kmm) + uu(ji-1,jj  ,1,Kmm) )
-                  zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji  ,jj-1,1,Kmm) ) 
+                  zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji  ,jj-1,1,Kmm) )
                END_2D
-            CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T  
+            CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T
                DO_2D( 0, 0, 0, 0 )
-                  zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)  
+                  zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)
                   zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj)
                   zitx1(ji,jj) = 0.5 * ( u_ice(ji,jj  )     + u_ice(ji-1,jj    )     ) *  fr_i(ji,jj)
@@ -2570,12 +2572,12 @@
          IF( TRIM( sn_snd_crt%clvor ) == 'eastward-northward' ) THEN             ! Rotation of the components
             !                                                                     ! Ocean component
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->e', ztmp1 )       ! 1st component 
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->n', ztmp2 )       ! 2nd component 
-            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components 
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->e', ztmp1 )       ! 1st component
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->n', ztmp2 )       ! 2nd component
+            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components
             zoty1(:,:) = ztmp2(:,:)
             IF( ssnd(jps_ivx1)%laction ) THEN                                     ! Ice component
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component 
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component 
-               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components 
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component
+               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components
                zity1(:,:) = ztmp2(:,:)
             ENDIF
@@ -2602,95 +2604,95 @@
          IF( ssnd(jps_ivy1)%laction )   CALL cpl_snd( jps_ivy1, isec, RESHAPE ( zity1, (/jpi,jpj,1/) ), info )   ! ice   y current 1st grid
          IF( ssnd(jps_ivz1)%laction )   CALL cpl_snd( jps_ivz1, isec, RESHAPE ( zitz1, (/jpi,jpj,1/) ), info )   ! ice   z current 1st grid
-         ! 
-      ENDIF
-      !
-      !                                                      ! ------------------------- ! 
-      !                                                      !  Surface current to waves ! 
-      !                                                      ! ------------------------- ! 
-      IF( ssnd(jps_ocxw)%laction .OR. ssnd(jps_ocyw)%laction ) THEN 
-          !     
-          !                                                  j+1  j     -----V---F 
-          ! surface velocity always sent from T point                    !       | 
-          !                                                       j      |   T   U 
-          !                                                              |       | 
-          !                                                   j   j-1   -I-------| 
-          !                                               (for I)        |       | 
-          !                                                             i-1  i   i 
-          !                                                              i      i+1 (for I) 
-          SELECT CASE( TRIM( sn_snd_crtw%cldes ) ) 
-          CASE( 'oce only'             )      ! C-grid ==> T 
+         !
+      ENDIF
+      !
+      !                                                      ! ------------------------- !
+      !                                                      !  Surface current to waves !
+      !                                                      ! ------------------------- !
+      IF( ssnd(jps_ocxw)%laction .OR. ssnd(jps_ocyw)%laction ) THEN
+          !
+          !                                                  j+1  j     -----V---F
+          ! surface velocity always sent from T point                    !       |
+          !                                                       j      |   T   U
+          !                                                              |       |
+          !                                                   j   j-1   -I-------|
+          !                                               (for I)        |       |
+          !                                                             i-1  i   i
+          !                                                              i      i+1 (for I)
+          SELECT CASE( TRIM( sn_snd_crtw%cldes ) )
+          CASE( 'oce only'             )      ! C-grid ==> T
              DO_2D( 0, 0, 0, 0 )
-                zotx1(ji,jj) = 0.5 * ( uu(ji,jj,1,Kmm) + uu(ji-1,jj  ,1,Kmm) ) 
-                zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji , jj-1,1,Kmm) )  
+                zotx1(ji,jj) = 0.5 * ( uu(ji,jj,1,Kmm) + uu(ji-1,jj  ,1,Kmm) )
+                zoty1(ji,jj) = 0.5 * ( vv(ji,jj,1,Kmm) + vv(ji , jj-1,1,Kmm) )
              END_2D
-          CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T   
+          CASE( 'weighted oce and ice' )      ! Ocean and Ice on C-grid ==> T
              DO_2D( 0, 0, 0, 0 )
-                zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   
-                zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj) 
-                zitx1(ji,jj) = 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj) 
-                zity1(ji,jj) = 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj) 
+                zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)
+                zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj)
+                zitx1(ji,jj) = 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj)
+                zity1(ji,jj) = 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj)
              END_2D
-             CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp,  zity1, 'T', -1.0_wp ) 
-          CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T  
+             CALL lbc_lnk_multi( 'sbccpl', zitx1, 'T', -1.0_wp,  zity1, 'T', -1.0_wp )
+          CASE( 'mixed oce-ice'        )      ! Ocean and Ice on C-grid ==> T
              DO_2D( 0, 0, 0, 0 )
-                zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   & 
-                   &         + 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj) 
-                zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj)   & 
-                   &         + 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj) 
+                zotx1(ji,jj) = 0.5 * ( uu   (ji,jj,1,Kmm) + uu   (ji-1,jj  ,1,Kmm) ) * zfr_l(ji,jj)   &
+                   &         + 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj)
+                zoty1(ji,jj) = 0.5 * ( vv   (ji,jj,1,Kmm) + vv   (ji  ,jj-1,1,Kmm) ) * zfr_l(ji,jj)   &
+                   &         + 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj)
              END_2D
           END SELECT
-         CALL lbc_lnk_multi( 'sbccpl', zotx1, ssnd(jps_ocxw)%clgrid, -1.0_wp, zoty1, ssnd(jps_ocyw)%clgrid, -1.0_wp ) 
-         ! 
-         ! 
-         IF( TRIM( sn_snd_crtw%clvor ) == 'eastward-northward' ) THEN             ! Rotation of the components 
-         !                                                                        ! Ocean component 
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->e', ztmp1 )       ! 1st component  
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->n', ztmp2 )       ! 2nd component  
-            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components  
-            zoty1(:,:) = ztmp2(:,:)  
-            IF( ssnd(jps_ivx1)%laction ) THEN                                     ! Ice component 
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component  
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component  
-               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components  
-               zity1(:,:) = ztmp2(:,:) 
-            ENDIF 
-         ENDIF 
-         ! 
-!         ! spherical coordinates to cartesian -> 2 components to 3 components 
-!         IF( TRIM( sn_snd_crtw%clvref ) == 'cartesian' ) THEN 
-!            ztmp1(:,:) = zotx1(:,:)                     ! ocean currents 
-!            ztmp2(:,:) = zoty1(:,:) 
-!            CALL oce2geo ( ztmp1, ztmp2, 'T', zotx1, zoty1, zotz1 ) 
-!            ! 
-!            IF( ssnd(jps_ivx1)%laction ) THEN           ! ice velocities 
-!               ztmp1(:,:) = zitx1(:,:) 
-!               ztmp1(:,:) = zity1(:,:) 
-!               CALL oce2geo ( ztmp1, ztmp2, 'T', zitx1, zity1, zitz1 ) 
-!            ENDIF 
-!         ENDIF 
-         ! 
-         IF( ssnd(jps_ocxw)%laction )   CALL cpl_snd( jps_ocxw, isec, RESHAPE ( zotx1, (/jpi,jpj,1/) ), info )   ! ocean x current 1st grid 
-         IF( ssnd(jps_ocyw)%laction )   CALL cpl_snd( jps_ocyw, isec, RESHAPE ( zoty1, (/jpi,jpj,1/) ), info )   ! ocean y current 1st grid 
-         !  
-      ENDIF 
-      ! 
-      IF( ssnd(jps_ficet)%laction ) THEN 
-         CALL cpl_snd( jps_ficet, isec, RESHAPE ( fr_i, (/jpi,jpj,1/) ), info ) 
-      ENDIF 
-      !                                                      ! ------------------------- ! 
-      !                                                      !   Water levels to waves   ! 
-      !                                                      ! ------------------------- ! 
-      IF( ssnd(jps_wlev)%laction ) THEN 
-         IF( ln_apr_dyn ) THEN  
-            IF( kt /= nit000 ) THEN  
-               ztmp1(:,:) = ssh(:,:,Kbb) - 0.5 * ( ssh_ib(:,:) + ssh_ibb(:,:) )  
-            ELSE  
-               ztmp1(:,:) = ssh(:,:,Kbb)  
-            ENDIF  
-         ELSE  
-            ztmp1(:,:) = ssh(:,:,Kmm)  
-         ENDIF  
-         CALL cpl_snd( jps_wlev  , isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ), info ) 
-      ENDIF 
+         CALL lbc_lnk_multi( 'sbccpl', zotx1, ssnd(jps_ocxw)%clgrid, -1.0_wp, zoty1, ssnd(jps_ocyw)%clgrid, -1.0_wp )
+         !
+         !
+         IF( TRIM( sn_snd_crtw%clvor ) == 'eastward-northward' ) THEN             ! Rotation of the components
+         !                                                                        ! Ocean component
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->e', ztmp1 )       ! 1st component
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->n', ztmp2 )       ! 2nd component
+            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components
+            zoty1(:,:) = ztmp2(:,:)
+            IF( ssnd(jps_ivx1)%laction ) THEN                                     ! Ice component
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component
+               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components
+               zity1(:,:) = ztmp2(:,:)
+            ENDIF
+         ENDIF
+         !
+!         ! spherical coordinates to cartesian -> 2 components to 3 components
+!         IF( TRIM( sn_snd_crtw%clvref ) == 'cartesian' ) THEN
+!            ztmp1(:,:) = zotx1(:,:)                     ! ocean currents
+!            ztmp2(:,:) = zoty1(:,:)
+!            CALL oce2geo ( ztmp1, ztmp2, 'T', zotx1, zoty1, zotz1 )
+!            !
+!            IF( ssnd(jps_ivx1)%laction ) THEN           ! ice velocities
+!               ztmp1(:,:) = zitx1(:,:)
+!               ztmp1(:,:) = zity1(:,:)
+!               CALL oce2geo ( ztmp1, ztmp2, 'T', zitx1, zity1, zitz1 )
+!            ENDIF
+!         ENDIF
+         !
+         IF( ssnd(jps_ocxw)%laction )   CALL cpl_snd( jps_ocxw, isec, RESHAPE ( zotx1, (/jpi,jpj,1/) ), info )   ! ocean x current 1st grid
+         IF( ssnd(jps_ocyw)%laction )   CALL cpl_snd( jps_ocyw, isec, RESHAPE ( zoty1, (/jpi,jpj,1/) ), info )   ! ocean y current 1st grid
+         !
+      ENDIF
+      !
+      IF( ssnd(jps_ficet)%laction ) THEN
+         CALL cpl_snd( jps_ficet, isec, RESHAPE ( fr_i, (/jpi,jpj,1/) ), info )
+      ENDIF
+      !                                                      ! ------------------------- !
+      !                                                      !   Water levels to waves   !
+      !                                                      ! ------------------------- !
+      IF( ssnd(jps_wlev)%laction ) THEN
+         IF( ln_apr_dyn ) THEN
+            IF( kt /= nit000 ) THEN
+               ztmp1(:,:) = ssh(:,:,Kbb) - 0.5 * ( ssh_ib(:,:) + ssh_ibb(:,:) )
+            ELSE
+               ztmp1(:,:) = ssh(:,:,Kbb)
+            ENDIF
+         ELSE
+            ztmp1(:,:) = ssh(:,:,Kmm)
+         ENDIF
+         CALL cpl_snd( jps_wlev  , isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ), info )
+      ENDIF
       !
       !  Fields sent by OPA to SAS when doing OPA<->SAS coupling
@@ -2709,5 +2711,5 @@
          CALL cpl_snd( jps_soce  , isec, RESHAPE ( ts(:,:,1,jp_sal,Kmm), (/jpi,jpj,1/) ), info )
       ENDIF
-      !                                                        ! first T level thickness 
+      !                                                        ! first T level thickness
       IF( ssnd(jps_e3t1st )%laction )  THEN
          CALL cpl_snd( jps_e3t1st, isec, RESHAPE ( e3t(:,:,1,Kmm)   , (/jpi,jpj,1/) ), info )
@@ -2731,5 +2733,5 @@
 #if defined key_si3
       !                                                      ! ------------------------- !
-      !                                                      ! Sea surface freezing temp ! 
+      !                                                      ! Sea surface freezing temp !
       !                                                      ! ------------------------- !
       ! needed by Met Office
@@ -2740,5 +2742,5 @@
       !
    END SUBROUTINE sbc_cpl_snd
-   
+
    !!======================================================================
 END MODULE sbccpl
Index: /NEMO/trunk/src/OCE/SBC/sbcmod.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcmod.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcmod.F90	(revision 14072)
@@ -16,5 +16,5 @@
    !!            4.0  ! 2016-06  (L. Brodeau) new general bulk formulation
    !!            4.0  ! 2019-03  (F. Lemarié & G. Samson)  add ABL compatibility (ln_abl=TRUE)
-   !!            4.2  ! 2020-12  (G. Madec, E. Clementi) modified wave forcing and coupling  
+   !!            4.2  ! 2020-12  (G. Madec, E. Clementi) modified wave forcing and coupling
    !!----------------------------------------------------------------------
 
@@ -28,4 +28,5 @@
    USE closea         ! closed seas
    USE phycst         ! physical constants
+   USE sbc_phy, ONLY : pp_cldf
    USE sbc_oce        ! Surface boundary condition: ocean fields
    USE trc_oce        ! shared ocean-passive tracers variables
@@ -46,5 +47,5 @@
    USE sbcssr         ! surface boundary condition: sea surface restoring
    USE sbcrnf         ! surface boundary condition: runoffs
-   USE sbcapr         ! surface boundary condition: atmo pressure 
+   USE sbcapr         ! surface boundary condition: atmo pressure
    USE sbcfwb         ! surface boundary condition: freshwater budget
    USE icbstp         ! Icebergs
@@ -139,5 +140,5 @@
          WRITE(numout,*) '         ocean-atmosphere coupled formulation       ln_cpl        = ', ln_cpl
          WRITE(numout,*) '         mixed forced-coupled     formulation       ln_mixcpl     = ', ln_mixcpl
-!!gm  lk_oasis is controlled by key_oasis3  ===>>>  It shoud be removed from the namelist 
+!!gm  lk_oasis is controlled by key_oasis3  ===>>>  It shoud be removed from the namelist
          WRITE(numout,*) '         OASIS coupling (with atm or sas)           lk_oasis      = ', lk_oasis
          WRITE(numout,*) '         components of your executable              nn_components = ', nn_components
@@ -162,5 +163,5 @@
       !                       !**  check option consistency
       !
-      IF(lwp) WRITE(numout,*)       !* Single / Multi - executable (NEMO / OPA+SAS) 
+      IF(lwp) WRITE(numout,*)       !* Single / Multi - executable (NEMO / OPA+SAS)
       SELECT CASE( nn_components )
       CASE( jp_iam_nemo )
@@ -194,5 +195,5 @@
       SELECT CASE( nn_ice )
       CASE( 0 )                        !- no ice in the domain
-      CASE( 1 )                        !- Ice-cover climatology ("Ice-if" model)  
+      CASE( 1 )                        !- Ice-cover climatology ("Ice-if" model)
       CASE( 2 )                        !- SI3  ice model
          IF( .NOT.( ln_blk .OR. ln_cpl .OR. ln_abl .OR. ln_usr ) )   &
@@ -202,5 +203,5 @@
             &                   CALL ctl_stop( 'sbc_init : CICE sea-ice model requires ln_blk or ln_cpl or ln_abl or ln_usr = T' )
          IF( lk_agrif                                )   &
-            &                   CALL ctl_stop( 'sbc_init : CICE sea-ice model not currently available with AGRIF' ) 
+            &                   CALL ctl_stop( 'sbc_init : CICE sea-ice model not currently available with AGRIF' )
       CASE DEFAULT                     !- not supported
       END SELECT
@@ -217,5 +218,5 @@
       !
       IF( sbc_ssr_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_init : unable to allocate sbc_ssr arrays' )
-      IF( .NOT.ln_ssr ) THEN               !* Initialize qrp and erp if no restoring 
+      IF( .NOT.ln_ssr ) THEN               !* Initialize qrp and erp if no restoring
          qrp(:,:) = 0._wp
          erp(:,:) = 0._wp
@@ -306,5 +307,5 @@
          &   CALL ctl_warn( 'sbc_init : diurnal cycle for qsr: the sampling of the diurnal cycle is too small...' )
       !
-   
+
       !                       !**  associated modules : initialization
       !
@@ -378,5 +379,5 @@
       !
       REAL(wp) ::     zthscl        ! wd  tanh scale
-      REAL(wp), DIMENSION(jpi,jpj) ::  zwdht, zwght  ! wd dep over wd limit, wgt  
+      REAL(wp), DIMENSION(jpi,jpj) ::  zwdht, zwght  ! wd dep over wd limit, wgt
 
       !!---------------------------------------------------------------------
@@ -408,9 +409,9 @@
       !
       !                                            !==  sbc formulation  ==!
-      !                                                   
+      !
       !
       SELECT CASE( nsbc )                                ! Compute ocean surface boundary condition
       !                                                  ! (i.e. utau,vtau, qns, qsr, emp, sfx)
-      CASE( jp_usr   )     ;   CALL usrdef_sbc_oce( kt, Kbb )                        ! user defined formulation 
+      CASE( jp_usr   )     ;   CALL usrdef_sbc_oce( kt, Kbb )                        ! user defined formulation
       CASE( jp_flx     )   ;   CALL sbc_flx       ( kt )                             ! flux formulation
       CASE( jp_blk     )
@@ -476,6 +477,6 @@
       IF( ln_icebergs    )   THEN
                                      CALL icb_stp( kt, Kmm )           ! compute icebergs
-         ! Icebergs do not melt over the haloes. 
-         ! So emp values over the haloes are no more consistent with the inner domain values. 
+         ! Icebergs do not melt over the haloes.
+         ! So emp values over the haloes are no more consistent with the inner domain values.
          ! A lbc_lnk is therefore needed to ensure reproducibility and restartability.
          ! see ticket #2113 for discussion about this lbc_lnk.
@@ -491,5 +492,5 @@
       ! Special treatment of freshwater fluxes over closed seas in the model domain
       ! Should not be run if ln_diurnal_only
-      IF( l_sbc_clo      )   CALL sbc_clo( kt )   
+      IF( l_sbc_clo      )   CALL sbc_clo( kt )
 
 !!$!RBbug do not understand why see ticket 667
@@ -497,5 +498,5 @@
 !!$      CALL lbc_lnk( 'sbcmod', emp, 'T', 1.0_wp )
       IF( ll_wd ) THEN     ! If near WAD point limit the flux for now
-         zthscl = atanh(rn_wd_sbcfra)                     ! taper frac default is .999 
+         zthscl = atanh(rn_wd_sbcfra)                     ! taper frac default is .999
          zwdht(:,:) = ssh(:,:,Kmm) + ht_0(:,:) - rn_wdmin1   ! do this calc of water
                                                      ! depth above wd limit once
Index: /NEMO/trunk/src/SAS/sbcssm.F90
===================================================================
--- /NEMO/trunk/src/SAS/sbcssm.F90	(revision 14071)
+++ /NEMO/trunk/src/SAS/sbcssm.F90	(revision 14072)
@@ -179,6 +179,9 @@
       TYPE(FLD_N) ::   sn_ssh, sn_e3t, sn_frq
       !!
+      TYPE(FLD_N) ::   sn_ifr, sn_tic, sn_ial
+      !!
       NAMELIST/namsbc_sas/ l_sasread, cn_dir, ln_3d_uve, ln_read_frq,   &
-         &                 sn_tem, sn_sal, sn_usp, sn_vsp, sn_ssh, sn_e3t, sn_frq
+         &                 sn_tem, sn_sal, sn_usp, sn_vsp, sn_ssh, sn_e3t, sn_frq, &
+         &                 sn_ifr, sn_tic, sn_ial
       !!----------------------------------------------------------------------
       !
